------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2007-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Qt4.Point_Fs;
with Qt4.Rects;
with Qt4.Size_Fs;
private with Qt_Ada.Internals.Value_Class_Sizes;
with System;

package Qt4.Rect_Fs is

   type Q_Rect_F is tagged private;

   function Create
     return Q_Rect_F;

   function Create
    (Topleft : in Qt4.Point_Fs.Q_Point_F'Class;
     Size : in Qt4.Size_Fs.Q_Size_F'Class)
       return Q_Rect_F;

   function Create
    (Topleft : in Qt4.Point_Fs.Q_Point_F'Class;
     Bottom_Right : in Qt4.Point_Fs.Q_Point_F'Class)
       return Q_Rect_F;

   function Create
    (Left : in Qt4.Q_Real;
     Top : in Qt4.Q_Real;
     Width : in Qt4.Q_Real;
     Height : in Qt4.Q_Real)
       return Q_Rect_F;

   function Create
    (Rect : in Qt4.Rects.Q_Rect'Class)
       return Q_Rect_F;

   procedure Adjust
    (Self : in out Q_Rect_F'Class;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real);

   function Adjusted
    (Self : in Q_Rect_F'Class;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real)
       return Q_Rect_F;

   function Bottom
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real;

   function Bottom_Left
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F;

   function Bottom_Right
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F;

   function Center
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F;

   function Contains
    (Self : in Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
       return Boolean;

   function Contains
    (Self : in Q_Rect_F'Class;
     X : in Qt4.Q_Real;
     Y : in Qt4.Q_Real)
       return Boolean;

   function Contains
    (Self : in Q_Rect_F'Class;
     R : in Q_Rect_F'Class)
       return Boolean;

   procedure Get_Coords
    (Self : in Q_Rect_F'Class;
     X_1 : out Qt4.Q_Real;
     Y_1 : out Qt4.Q_Real;
     X_2 : out Qt4.Q_Real;
     Y_2 : out Qt4.Q_Real);

   procedure Get_Rect
    (Self : in Q_Rect_F'Class;
     X : out Qt4.Q_Real;
     Y : out Qt4.Q_Real;
     W : out Qt4.Q_Real;
     H : out Qt4.Q_Real);

   function Height
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real;

   function Intersected
    (Self : in Q_Rect_F'Class;
     Other : in Q_Rect_F'Class)
       return Q_Rect_F;

   function Intersects
    (Self : in Q_Rect_F'Class;
     R : in Q_Rect_F'Class)
       return Boolean;

   function Is_Empty
    (Self : in Q_Rect_F'Class)
       return Boolean;

   function Is_Null
    (Self : in Q_Rect_F'Class)
       return Boolean;

   function Is_Valid
    (Self : in Q_Rect_F'Class)
       return Boolean;

   function Left
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real;

   procedure Move_Bottom
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Move_Bottom_Left
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Move_Bottom_Right
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Move_Center
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Move_Left
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Move_Right
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Move_To
    (Self : in out Q_Rect_F'Class;
     X : in Qt4.Q_Real;
     T : in Qt4.Q_Real);

   procedure Move_To
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Move_Top
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Move_Top_Left
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Move_Top_Right
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   function Normalized
    (Self : in Q_Rect_F'Class)
       return Q_Rect_F;

   function Right
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real;

   procedure Set_Bottom
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Set_Bottom_Left
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Set_Bottom_Right
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Set_Coords
    (Self : in out Q_Rect_F'Class;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real);

   procedure Set_Height
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Set_Left
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Set_Rect
    (Self : in out Q_Rect_F'Class;
     X : in Qt4.Q_Real;
     Y : in Qt4.Q_Real;
     W : in Qt4.Q_Real;
     H : in Qt4.Q_Real);

   procedure Set_Right
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Set_Size
    (Self : in out Q_Rect_F'Class;
     S : in Qt4.Size_Fs.Q_Size_F'Class);

   procedure Set_Top
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Set_Top_Left
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Set_Top_Right
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   procedure Set_Width
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Set_X
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   procedure Set_Y
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real);

   function Size
    (Self : in Q_Rect_F'Class)
       return Qt4.Size_Fs.Q_Size_F;

   function To_Aligned_Rect
    (Self : in Q_Rect_F'Class)
       return Qt4.Rects.Q_Rect;

   function To_Rect
    (Self : in Q_Rect_F'Class)
       return Qt4.Rects.Q_Rect;

   function Top
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real;

   function Top_Left
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F;

   function Top_Right
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F;

   procedure Translate
    (Self : in out Q_Rect_F'Class;
     Dx : in Qt4.Q_Real;
     Dy : in Qt4.Q_Real);

   procedure Translate
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class);

   function Translated
    (Self : in Q_Rect_F'Class;
     Dx : in Qt4.Q_Real;
     Dy : in Qt4.Q_Real)
       return Q_Rect_F;

   function Translated
    (Self : in Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
       return Q_Rect_F;

   function United
    (Self : in Q_Rect_F'Class;
     Other : in Q_Rect_F'Class)
       return Q_Rect_F;

   function Width
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real;

   function X
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real;

   function Y
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real;

   function "="
    (R_1 : in Q_Rect_F;
     R_2 : in Q_Rect_F)
       return Boolean;

   package Internals is

      type QRectF is private;

      type QRectF_Access is access all QRectF;
      pragma Convention (C, QRectF_Access);

      function QRectF_View
       (Item : in Q_Rect_F'Class)
          return QRectF_Access;
      pragma Inline (QRectF_View);

      function To_Pointer
       (Address : in System.Address)
          return QRectF_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : in QRectF_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : in Internals.QRectF_Access)
          return Q_Rect_F;

   private

      type QRectF is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QRectF_C_Size_Of);
      end record;
      pragma Convention (C, QRectF);

   end Internals;

   package Thin is

      function copy_QRectF
       (Cpp_Object : not null access Internals.QRectF)
        return not null access Internals.QRectF;
      pragma Import (C, copy_QRectF, "__Qt4Ada_copy_QRectF");

   end Thin;

private

   type Q_Rect_F is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QRectF;
      Object  : Internals.QRectF_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Rect_F);

   overriding
   procedure Finalize (Self : in out Q_Rect_F);

   overriding
   procedure Initialize (Self : in out Q_Rect_F);

end Qt4.Rect_Fs;
